function result=CalcSparsity(coef, mode)
% this function calculate the sparsity of the coefficient
% first the coeffcient is normalize by its max absolute term
% x=    0, if |x|<sigma
%       |x|, else
% if coef is a matrix, we deal with each column independently.
if mode
    coef=abs(full(coef));
    sigma=0.1;
    theta=max(coef)*sigma;
    result=zeros(1, size(coef, 2));
    for i=1:size(coef, 2)
        tmp=coef(:, i);
        tmp(tmp<theta(i))=0;
        tmp(tmp>=theta(i))=1;
        result(i)=sum(tmp);
    end
else
    coef=abs(full(coef));
    tmp=sum(coef);
    coef=sort(coef, 1, 'descend');
    coef=coef([1:3], :);
    result=sum(coef)./tmp;
end