%demo
%% =========================================================================
disp('down sample matrix');
if dataset==1
    disp('YaleB Extended database');
    sample=CreateSample(192*168, 504);
else
    if dataset==0
        disp('AR database');
        sample=CreateSample(165*120, 540);
    end
end
%% =========================================================================
disp('src');
disp('load matrix');
% load('src_prm.mat');
if dataset==1
    disp('YaleB Extended database');
    sample=CreateSample(192*168, 504);
    % if you organize the image by the order of subject id, then ind_image 
    % is not needed
    param_train=struct('no_people', 38, 'no_atom', 32, 'support', 64, 'sample', sample);
    param_test=struct('no_people', 38, 'no_atom', 32, 'support', 64, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
else
    if dataset==0
        disp('AR database');
        sample=CreateSample(165*120, 540);
    end
    param_train=struct('no_people', 100, 'no_atom', 13, 'support', 26, 'sample', sample);
    param_test=struct('no_people', 100, 'no_atom', 13, 'support', 26, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
end
disp('train dictionary');
% param_train.sample=sample;
[dict, output]=SRCTrain('.', 'bmp', param_train);

disp('test the image');
cd test;
% param_test.sample=sample;
[m_i, m_coef, m_residual]=SRCTestImages('.', 'bmp', dict, param_test);

disp('save the result');
cd ..
save('src.mat', 'dict', 'm_residual', 'm_i', 'm_coef');
%% =========================================================================
disp('ksvd');
disp('load matrix');
% load('parameter.mat');
if dataset==1
    disp('YaleB Extended database');
    sample=CreateSample(192*168, 504);
    % compress the dictionary by 1/4
    param_train=struct('no_people', 38, 'no_atom', 8, 'no_image', 32, 'support', 16, 'sample', sample, 'iteration', 100, 'alpha', 255, 'label', []);
    param_test=struct('no_people', 38, 'no_atom', 32, 'support', 64, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
else
    if dataset==0
        disp('AR database');
        sample=CreateSample(165*120, 540);
    end
    param_train=struct('no_people', 100, 'no_atom', 6, 'no_image', 13, 'support', 12, 'sample', sample, 'iteration', 100, 'alpha', 255, 'label', []);
    param_test=struct('no_people', 100, 'no_atom', 6, 'support', 12, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
end

disp('train dictionary');
% param_train.sample=sample;
[dict, W, output]=PlainKSVDTrain('.', 'bmp', param_train);
coef=output.CoefMatrix;

disp('test the image');
cd test;
% param_test.sample=sample;
[m_i, m_coef, m_residual]=ClassifyImages('.', 'bmp', dict, W, param_test);

disp('save the result');
cd ..
save('ksvd.mat', 'W', 'coef', 'dict', 'm_residual', 'm_i', 'm_coef');
%% =========================================================================
disp('baseline');
disp('load matrix');
% load('parameter.mat');
if dataset==1
    disp('YaleB Extended database');
    sample=CreateSample(192*168, 504);
    % compress the dictionary by 1/4
    param_train=struct('no_people', 38, 'no_atom', 8, 'no_image', 32, 'support', 16, 'sample', sample, 'iteration', 100, 'alpha', 255, 'label', []);
    param_test=struct('no_people', 38, 'no_atom', 32, 'support', 64, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
else
    if dataset==0
        disp('AR database');
        sample=CreateSample(165*120, 540);
    end
    param_train=struct('no_people', 100, 'no_atom', 6, 'no_image', 13, 'support', 12, 'sample', sample, 'iteration', 100, 'alpha', 255, 'label', []);
    param_test=struct('no_people', 100, 'no_atom', 6, 'support', 12, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
end
disp('train dictionary');
% param_train.sample=sample;
[dict, W, output]=BaselineTrain('.', 'bmp', param_train);
coef=output.CoefMatrix;

disp('test the image');
cd test;
% param_test.sample=sample;
[m_i, m_coef, m_residual]=ClassifyImages('.', 'bmp', dict, W, param_test);

disp('save the result');
cd ..
save('baseline.mat', 'W', 'coef', 'dict', 'm_residual', 'm_i', 'm_coef');
%% =========================================================================
disp('dksvd');
disp('load matrix');
% load('parameter.mat');
if dataset==1
    disp('YaleB Extended database');
    sample=CreateSample(192*168, 504);
    % compress the dictionary by 1/4
    param_train=struct('no_people', 38, 'no_atom', 8, 'no_image', 32, 'support', 16, 'sample', sample, 'iteration', 100, 'alpha', 255, 'label', []);
    param_test=struct('no_people', 38, 'no_atom', 32, 'support', 64, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
else
    if dataset==0
        disp('AR database');
        sample=CreateSample(165*120, 540);
    end
    param_train=struct('no_people', 100, 'no_atom', 6, 'no_image', 13, 'support', 12, 'sample', sample, 'iteration', 100, 'alpha', 255, 'label', []);
    param_test=struct('no_people', 100, 'no_atom', 6, 'support', 12, 'display', 0, 'test', 0, 'number', 3, 'save', 0, 'sample', sample);
end
disp('train dictionary');
% param_train.sample=sample;
[dict, W, output]=DKSVDTrain('.', 'bmp', param_train);
coef=output.CoefMatrix;

disp('test the image');
cd test;
% param_test.sample=sample;
[m_i, m_coef, m_residual]=ClassifyImages('.', 'bmp', dict, W, param_test);

disp('save the result');
cd ..
save('dksvd.mat', 'W', 'coef', 'dict', 'm_residual', 'm_i', 'm_coef');
